#include <SparkFunBME280.h>
#include <stdint.h>
#include <OneWire.h>
#include <DallasTemperature.h>
#include <Wire.h>
#include "Adafruit_FONA.h"

//#include "SPI.h"  // Delete this!

#define FONA_RX 2
#define FONA_TX 10
#define FONA_RST 4
#define ONE_WIRE_BUS 3
#define TEMPERATURE_PRECISION 12
OneWire oneWire(ONE_WIRE_BUS);
DallasTemperature sensors(&oneWire);
DeviceAddress sensor0,sensor1,sensor2,sensor3;

// Connect Fona RX to Arduino Mega D2
// Connect Fona TX to Arduino Mega D10
// Connect Nano A5 to Maga SCL
// Connect Nano A4 to Mega SDA
float boilerTemp;
float refluxTemp;
float hydroTemp;
float soilTemp;
int deviceCount =0;
float tempC;
// this is a large buffer for replies
char replybuffer[255];
String initiator;
String dataString;
const char webAddress[100] = "http://www.goatindustries.co.uk/weather2/send.php?";
char url[120];

String nothing;
int numberId =0;
String resultForNumberId;
String numberA;
int stringLength =0;
String testad;
float result101=0.00;
float result102=0.00;
float result103=0.00;
float result104=0.00;
float result105=0.00;
float result106=0.00;
float result107=0.00;
float result108=0.00;
int w=10;
int n=0;
int i=0;
String compileA;
char rabbits[10];
int a;
int k;
int z=0;

float pressure =0.00;
float BME280Temperature =0.00;
float humidity =0.00;
BME280 mySensor;

float moistureValue = 0;
float moisture =0;

#include <SoftwareSerial.h>
SoftwareSerial fonaSS = SoftwareSerial(FONA_TX, FONA_RX);
SoftwareSerial *fonaSerial = &fonaSS;

//Connect Rx on Fona to Tx1 on mega or due:
//HardwareSerial *fonaSerial = &Serial1;

Adafruit_FONA fona = Adafruit_FONA(FONA_RST);
uint8_t readline(char *buff, uint8_t maxbuff, uint16_t timeout = 0);
uint8_t type;
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void setup() 
{
  Serial.begin(115200);
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  pinMode(11,OUTPUT);   // Soil Moisture power.
  n=0;
  while(n<10)
  {
    digitalWrite(11,HIGH);
    n++;
    delay(10);    
    moistureValue = analogRead(A2) + moistureValue;
    digitalWrite(11,LOW);
    Serial.print("Moisture:  ");Serial.println(moistureValue);
  }
  moisture = (moistureValue/10 -60.4)/9.017;
  Serial.print("Moisture:  ");Serial.println(moisture);Serial.println();
  
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  mySensor.settings.commInterface = I2C_MODE;
  mySensor.settings.I2CAddress = 0x77; 
    //***Operation settings*****************************//
  
  //renMode can be:
  //  0, Sleep mode
  //  1 or 2, Forced mode
  //  3, Normal mode
  mySensor.settings.runMode = 3; //Normal mode
  
  //tStandby can be:
  //  0, 0.5ms
  //  1, 62.5ms
  //  2, 125ms
  //  3, 250ms
  //  4, 500ms
  //  5, 1000ms
  //  6, 10ms
  //  7, 20ms
  mySensor.settings.tStandby = 0;
  
  //filter can be off or number of FIR coefficients to use:
  //  0, filter off
  //  1, coefficients = 2
  //  2, coefficients = 4
  //  3, coefficients = 8
  //  4, coefficients = 16
  mySensor.settings.filter = 0;
  
  //tempOverSample can be:
  //  0, skipped
  //  1 through 5, oversampling *1, *2, *4, *8, *16 respectively
  mySensor.settings.tempOverSample = 4;

  //pressOverSample can be:
  //  0, skipped
  //  1 through 5, oversampling *1, *2, *4, *8, *16 respectively
    mySensor.settings.pressOverSample = 4;
  
  //humidOverSample can be:
  //  0, skipped
  //  1 through 5, oversampling *1, *2, *4, *8, *16 respectively
  mySensor.settings.humidOverSample = 4;
  
  Serial.print("Program Started\n");
  Serial.print("Starting BME280... result of .begin(): 0x");
  
  //Calling .begin() causes the settings to be loaded
  delay(10);  //Make sure sensor had enough time to turn on. BME280 requires 2ms to start up.
  Serial.println(mySensor.begin(), HEX);

  Serial.print("Displaying ID, reset and ctrl regs\n");
  
  Serial.print("ID(0xD0): 0x");
  Serial.println(mySensor.readRegister(BME280_CHIP_ID_REG), HEX);
  Serial.print("Reset register(0xE0): 0x");
  Serial.println(mySensor.readRegister(BME280_RST_REG), HEX);
  Serial.print("ctrl_meas(0xF4): 0x");
  Serial.println(mySensor.readRegister(BME280_CTRL_MEAS_REG), HEX);
  Serial.print("ctrl_hum(0xF2): 0x");
  Serial.println(mySensor.readRegister(BME280_CTRL_HUMIDITY_REG), HEX);

  Serial.print("\n\n");

  Serial.print("Displaying all regs\n");
  uint8_t memCounter = 0x80;
  uint8_t tempReadData;
  for(int rowi = 8; rowi < 16; rowi++ )
  {
    Serial.print("0x");
    Serial.print(rowi, HEX);
    Serial.print("0:");
    for(int coli = 0; coli < 16; coli++ )
    {
      tempReadData = mySensor.readRegister(memCounter);
      Serial.print((tempReadData >> 4) & 0x0F, HEX);//Print first hex nibble
      Serial.print(tempReadData & 0x0F, HEX);//Print second hex nibble
      Serial.print(" ");
      memCounter++;
    }
    Serial.print("\n");
  }
  
  
  Serial.print("\n\n");
  
  Serial.print("Displaying concatenated calibration words\n");
  Serial.print("dig_T1, uint16: ");
  Serial.println(mySensor.calibration.dig_T1);
  Serial.print("dig_T2, int16: ");
  Serial.println(mySensor.calibration.dig_T2);
  Serial.print("dig_T3, int16: ");
  Serial.println(mySensor.calibration.dig_T3);
  
  Serial.print("dig_P1, uint16: ");
  Serial.println(mySensor.calibration.dig_P1);
  Serial.print("dig_P2, int16: ");
  Serial.println(mySensor.calibration.dig_P2);
  Serial.print("dig_P3, int16: ");
  Serial.println(mySensor.calibration.dig_P3);
  Serial.print("dig_P4, int16: ");
  Serial.println(mySensor.calibration.dig_P4);
  Serial.print("dig_P5, int16: ");
  Serial.println(mySensor.calibration.dig_P5);
  Serial.print("dig_P6, int16: ");
  Serial.println(mySensor.calibration.dig_P6);
  Serial.print("dig_P7, int16: ");
  Serial.println(mySensor.calibration.dig_P7);
  Serial.print("dig_P8, int16: ");
  Serial.println(mySensor.calibration.dig_P8);
  Serial.print("dig_P9, int16: ");
  Serial.println(mySensor.calibration.dig_P9);
  
  Serial.print("dig_H1, uint8: ");
  Serial.println(mySensor.calibration.dig_H1);
  Serial.print("dig_H2, int16: ");
  Serial.println(mySensor.calibration.dig_H2);
  Serial.print("dig_H3, uint8: ");
  Serial.println(mySensor.calibration.dig_H3);
  Serial.print("dig_H4, int16: ");
  Serial.println(mySensor.calibration.dig_H4);
  Serial.print("dig_H5, int16: ");
  Serial.println(mySensor.calibration.dig_H5);
  Serial.print("dig_H6, uint8: ");
  Serial.println(mySensor.calibration.dig_H6);
    
  Serial.println(); 
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//Temperature stuff
  sensors.begin();
  // locate devices on the bus
  Serial.print("Locating devices...");
  Serial.print("Found ");
  deviceCount = sensors.getDeviceCount(), DEC;
  Serial.print(deviceCount);
  Serial.println(" devices.");
  
  if (!sensors.getAddress(sensor0, 0)) Serial.println("Unable to find address for Device 0"); 
  if (!sensors.getAddress(sensor1, 1)) Serial.println("Unable to find address for Device 1"); 
  if (!sensors.getAddress(sensor2, 2)) Serial.println("Unable to find address for Device 2"); 
  if (!sensors.getAddress(sensor3, 3)) Serial.println("Unable to find address for Device 3"); 
  
  sensors.setResolution(sensor0, TEMPERATURE_PRECISION);
  sensors.setResolution(sensor1, TEMPERATURE_PRECISION);
  sensors.setResolution(sensor2, TEMPERATURE_PRECISION);
  sensors.setResolution(sensor3, TEMPERATURE_PRECISION);
  
  Serial.print("Device 0 Address: ");
  printAddress(sensor0);
  Serial.println();

  Serial.print("Device 1 Address: ");
  printAddress(sensor1);
  Serial.println();
 
  Serial.print("Device 2 Address: ");
  printAddress(sensor2);
  Serial.println(); 
  
  Serial.print("Device 3 Address: ");
  printAddress(sensor3);
  Serial.println();   
  
  Serial.println(""); 

  printTemperature();

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////    
  pinMode (5,OUTPUT); // Call back to master upon successful transmission.
  digitalWrite(5, LOW);
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////  
  pinMode(13, OUTPUT);
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  
  while (!Serial);                           // Use this for initiating program by opening of serial monitor. Delete in normal operation.

  Serial.println(F("FONA basic test"));
  Serial.println(F("Initialiking....(May take 3 seconds)"));


  fonaSerial->begin(4800);
  if (! fona.begin(*fonaSerial)) {
    Serial.println(F("Couldn't find FONA"));
//   while (1);
  }
  type = fona.type();
  Serial.println(F("FONA is OK"));
  Serial.print(F("Found "));
  switch (type) {
    case FONA800H:
      Serial.println(F("FONA 800H")); break;
  }
  //networkStatus();   // Check the network is available. Home is good.
  
        Serial.println("");
        Serial.println("Checking that GPRS is turned off to start with .........");
  fona.setGPRSNetworkSettings(F("pp.vodafone.co.uk"), F("wap"), F("wap"));   // Change these settings! (Network APN, username ,password)
delay (1000);
        // Turn off GPRS:
        if (!fona.enableGPRS(false))
        Serial.println(F("No - Failed to turn off"));
        Serial.println("If the line above says OK, then GPRS has just been turned off");
delay (1000);
    //networkStatus();   // Check the network is available. Home is good.
    //ledFastFlash();
    turnOnGPRS();

    turnOnGPRS();

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
   Serial.println("Waiting for data from i2c  ...........");  
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  Wire.begin(11);                // join i2c bus with address #11
  Wire.onReceive(receiveEvent); // register event
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////  
}
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void loop() 
  {
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
      if (z>0)              // This loop is initiated if z is greater than 1. The value of z is given by the reciept of I2C data
  {   
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  Serial.println();   
  BME280Temperature = mySensor.readTempC();
  Serial.print("Temperature: ");
  Serial.print(BME280Temperature, 2);
  Serial.println(" degrees C");
  pressure = mySensor.readFloatPressure()/100;
  Serial.print("Pressure: ");
  Serial.print(pressure, 0);
  Serial.println(" Pa");
  humidity = mySensor.readFloatHumidity();
  Serial.print("%RH: ");
  Serial.print(humidity, 2);
  Serial.println(" %");
  
  Serial.println();    
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  delay(5000);
  Serial.print(F("FONA> "));

   // ledSlowFlash();
   result101=soilTemp;
   result102=boilerTemp;
   
   Serial.println("");
   Serial.print("Result 101:   ");Serial.println(result101,2);
   Serial.print("Result 102:   ");Serial.println(result102,2);
   Serial.print("Result 103:   ");Serial.println(result103,2);
   Serial.print("Result 104:   ");Serial.println(result104,2);
   Serial.print("Result 105:   ");Serial.println(result105,2);
   Serial.print("Result 106:   ");Serial.println(result106,2);
   Serial.print("Result 107:   ");Serial.println(result107,2);
                 
        // read website URL
        uint16_t statuscode;
        int16_t length;
        char url[180];
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////        BME280Temperature
// This is where the data is compiled into a character ....
// result101 is soil temperature, result102 is out temperature, result105 is callback,
  dataString =  initiator + webAddress + "tempout="+result102 + "&tempsoil="+result101 + "&windgust="+result103 + "&windspeed="+result104 + "&rain="+result106 + "&moisture="+moisture + "&tempint="+BME280Temperature + "&pressure="+pressure + "&humidity="+humidity + "&volts="+result108 + "&windway="+result107;
  // To add another temperature reading we would need: +"&tempB="+tempB 
  int n = dataString.length();

  Serial.print("Data string to send:     ");Serial.println(dataString);   
  Serial.print("Size of string:  ");Serial.println(n);
  // Builds the url character:
      for (int aa=0;aa<=n;aa++)                                              
      {
          url[aa] = dataString[aa];
      }
  Serial.print("Character data to send:  ");Serial.println(url);
  Serial.println("");  
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////  
//..... and sent out via HTTP to a PHP file called send.php ready to recieve it.

        Serial.print("Sending url .... ");
        Serial.print("Compiled url is: ");Serial.println(url);
        Serial.println(F("****"));
        if (!fona.HTTP_GET_start(url, &statuscode, (uint16_t *)&length)) {
          Serial.println("Failed!");
        }
        while (length > 0) {
          while (fona.available()) {
            char c = fona.read();
     
            // Serial.write is too slow, we'll write directly to Serial register!
#if defined(__AVR_ATmega328P__) || defined(__AVR_ATmega168__)
            loop_until_bit_is_set(UCSR0A, UDRE0); /* Wait until data register empty. */
            UDR0 = c;
#else
            digitalWrite(5, HIGH);   // Call back to Master to say that tranmission was successful.
            digitalWrite(13, HIGH);   // turn the LED on (HIGH is the voltage level)
            delay(100);              // wait for a second
            digitalWrite(13, LOW);    // turn the LED off by making the voltage LOW
            Serial.write(c);
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#endif
            length--;
            if (! length) break;
          }
        }
        Serial.println(F("\n****"));
        fona.HTTP_GET_end();
        Serial.println("Wait for 10 seconds ...........");

        delay (10000);
        
        // Turn off GPRS:
        if (!fona.enableGPRS(false))
        Serial.println(F("No - Failed to turn off"));
        Serial.println("GPRS turned off?");

  while (fona.available()) {
  Serial.write(fona.read());
  }
  z=0;
  Serial.println("Waiting for data from i2c  ..........."); 
  }
}
// End of main loop.
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void turnOnGPRS()
{
        delay (10000);
        Serial.println("Now attempting to turn on GPRS .........");
     //   if (!fona.enableGPRS(true))
     //   Serial.println(F("No - Failed to turn on"));
     //   Serial.println("GPRS is on if the line above shows 'OK'");
     //   Serial.println("Wait for 10 seconds to make sure GPRS is on ...........");        
     //   delay (10000);
        if (fona.enableGPRS(true))
        ledFastFlashB();                          // Indicates a connect to GPRS.

        //Serial.println(("No - Failed to turn on"));
}
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void networkStatus()
      {
        //delay(10000);
        // read the network/cellular status
        uint8_t n = fona.getNetworkStatus();
        Serial.print(F("Network status "));
        Serial.print(n);
        Serial.print(F(": "));
        if (n == 0) Serial.println(F("Not registered"));
        if (n == 1) Serial.println(F("Registered (home)"));
        if (n == 2) Serial.println(F("Not registered (searching)"));
        if (n == 3) Serial.println(F("Denied"));
        if (n == 4) Serial.println(F("Unknown"));
        if (n == 5) Serial.println(F("Registered roaming"));
  
      }
void receiveEvent(int bytes)
{
  //delay(5000); // wait for data to be sent.
  a=20;
  while (a>0) // This looks for the correct numberId to iniate the next if command.
  {
  numberId = Wire.read(); 
//  Serial.print("Possible number Id:   ");Serial.println(numberId); 
  
  n=-1;
  compileA = nothing;
  testad = nothing;
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////  
 //   Serial.println(""); 
    if (numberId==101)
    {
    unravelData();
    result101 = (rabbits+nothing).toInt()/100.00;
    }
    if (numberId==102)
    {
    unravelData();
    result102 = (rabbits+nothing).toInt()/100.00;    
    }
    if (numberId==103)
    {
    unravelData();
    result103 = (rabbits+nothing).toInt()/100.00;    
    }
    if (numberId==104)
    {
    unravelData();
    result104 = (rabbits+nothing).toInt()/100.00;    
    }
    if (numberId==105)
    {
    unravelData();
    result105 = (rabbits+nothing).toInt()/100.00;  
    }
    if (numberId==106)
    {
    unravelData();
    result106 = (rabbits+nothing).toInt()/100.00;  
    }    
    if (numberId==107)
    {
    unravelData();
    result107 = (rabbits+nothing).toInt()/100.00;  
    }   
    if (numberId==108)
    {
    unravelData();
    result108 = (rabbits+nothing).toInt()/100.00;  
    }     
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////      
  a--; 
  delay(100);
  }
   delay(10); 
   z=1;                 // recieveEvent is on an interrupt so when it's triggered it changes z to 1 and allows main loop. 
}
////////////////////////////////////////////////////////////////////////////////////////////////////////
void unravelData()
{
     a=10;
    stringLength = Wire.read(); 
      while (n<stringLength)
      {
      compileA = testad + compileA;
      testad = nothing + Wire.read(); // This is a string.
      n++;

  //    Serial.print("Compile:  ");Serial.println(compileA); 
      }
    
  numberA = compileA;
//  Serial.print("NumberA:  ");Serial.println(numberA); 
//  Serial.print("String length:   ");Serial.println(stringLength); 
  
 //Builds the rabbits character:
      i=stringLength;
      for (int aa=0;aa<=i;aa++)                                              
      {
          rabbits[aa] = compileA[aa];
      }  
 //Now create a string in which the last 3 characters represent the ID. The string can have the last four characters removed before being processed at the next stage.
      resultForNumberId = nothing + rabbits +" & " + numberId;
   
 //   Serial.print("rabbits:  ");Serial.println(rabbits);  
 //   Serial.print("Result for number Id: ");Serial.print(numberId); Serial.print(" is: "); Serial.println(resultForNumberId );
    Serial.println("");  
}     
void ledSlowFlash()
{
  digitalWrite(13, HIGH);   // turn the LED on (HIGH is the voltage level)
  delay(1000);              // wait for a second
  digitalWrite(13, LOW);    // turn the LED off by making the voltage LOW
}
void ledFastFlash()
{
  k=0;
  while(k<10)
  {
    digitalWrite(13, HIGH);   // turn the LED on (HIGH is the voltage level)
    delay(100);              // wait for a second
    digitalWrite(13, LOW);    // turn the LED off by making the voltage LOW
    delay(100);
    k++;
  }
}
void ledFastFlashB()
{
  k=0;
  while(k<20)
  {
    digitalWrite(11, HIGH);   // turn the LED on (HIGH is the voltage level)
    delay(100);              // wait for a second
    digitalWrite(11, LOW);    // turn the LED off by making the voltage LOW
    delay(100);
    k++;
  }
}
void printTemperature()
{
  Serial.println("  ");
  
  sensors.requestTemperatures();  
  Serial.print("Boiler Temp: ");
  boilerTemp =sensors.getTempCByIndex(1)-0.76; // Change the index value accordingly.
  Serial.println(boilerTemp); 
  
  sensors.requestTemperatures();  
  Serial.print("Reflux Temp: ");
  refluxTemp =sensors.getTempCByIndex(2)-0.76; // Change the index value accordingly.
  Serial.println(refluxTemp); 

  sensors.requestTemperatures();  
  Serial.print("Condensor Temp: ");
  soilTemp =sensors.getTempCByIndex(0)-0.76; // Change the index value accordingly.
  Serial.println(soilTemp); 

  sensors.requestTemperatures();  
  Serial.print("Hydrometer Temp: ");
  hydroTemp =sensors.getTempCByIndex(3)-0.76; // Change the index value accordingly.
  Serial.println(hydroTemp); 
  
  Serial.println("  ");
  tempC=boilerTemp;

}  
void printAddress(DeviceAddress deviceAddress)
{
  for (uint8_t i = 0; i < 8; i++)
  {
    // zero pad the address if necessary
    if (deviceAddress[i] < 16) Serial.print("0");
    Serial.print(deviceAddress[i], HEX);
  }
}

